if not fatalities then return end

local FirePillar = "FirePillar"

local function generateHFForPlayer(p)
    if p and p.valid and p.mo and p.mo.valid then
        return {{p.name, p.skincolor}, {skins[p.mo.skin].facemmap, p.skincolor}, p}
    else
        return {{}, {}}
    end
end

local STARTTIME = 6*TICRATE + (3*TICRATE/4)

local TurnAroundTime = 3*TICRATE/4
local TurnAroundOffset = -90*ANG1

local FireGrowthRate = 64*FRACUNIT

local k_invincibilitytimer = k_invincibilitytimer
local k_hyudorotimer = k_hyudorotimer
local k_growshrinktimer = k_growshrinktimer
local k_squishedtimer = k_squishedtimer
local k_respawn = k_respawn
local k_spinouttimer = k_spinouttimer
local pw_flashing = pw_flashing

freeslot(
    "MT_FIREPILLAR",

	"MT_FIREPILLAR_FIRE",
	"MT_FIREPILLAR_FIRESPAWN",
	
	"S_FIREPILLAR_START",
	"S_FIREPILLAR_WAIT",
	"S_FIREPILLAR_WAIT_LONG",
	"S_FIREPILLAR_WARN",
	"S_FIREPILLAR_ACTIVE",
	
	"S_FIREPILLAR_FIRE",
	"S_FIREPILLAR_FIREDEAD",
	"S_FIREPILLAR_FIRESPAWN"
)

--- uses extravalue1 to delay the cycle if the thing flag extra is set in-map
mobjinfo[MT_FIREPILLAR] = {
	doomednum = 2666,
    spawnstate = S_FIREPILLAR_START,
    spawnhealth = 9000,
    radius = 64*FRACUNIT,
    height = 50*FRACUNIT,
    flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING|MF_NOGRAVITY
}

mobjinfo[MT_FIREPILLAR_FIRE] = {
	doomednum = -1,
    spawnstate = S_FIREPILLAR_FIRE,
    spawnhealth = 9000,
	deathstate = S_FIREPILLAR_FIREDEAD,
    radius = 32*FRACUNIT,
    height = 48*FRACUNIT,
    flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_SPECIAL
}

mobjinfo[MT_FIREPILLAR_FIRESPAWN] = {
	doomednum = -1,
    spawnstate = S_FIREPILLAR_FIRESPAWN,
    spawnhealth = 9000,
    radius = 8*FRACUNIT,
    height = 8*FRACUNIT,
    flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING|MF_SCENERY|MF_NOGRAVITY
}

function A_FirePillarWait(mo)
	// only runs the first time it waits
	if mo.spawnpoint ~= nil and ((mo.spawnpoint.options & 1) == 1) and not mo.extravalue1 then
		mo.extravalue1 = 1
		mo.state = S_FIREPILLAR_WAIT_LONG
	end
	return
end

function A_FirePillarWarn(mo)
	local smoldering = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SMOLDERING)
	smoldering.tics = TICRATE*3
	smoldering.scale = 3*FRACUNIT/2
	return
end

function A_FirePillarActive(mo)
	for i = 1, 4 do
        local truc = P_SpawnMobj(mo.x, mo.y, mo.z, MT_BOOMPARTICLE)
        truc.color = SKINCOLOR_KETCHUP
        truc.momx = P_RandomRange(-12, 12)*mapobjectscale
        truc.momy = P_RandomRange(-12, 12)*mapobjectscale
        truc.momz = P_RandomRange(48, 56)*mapobjectscale
        truc.tics = TICRATE*2;
    end
	
	local spawner = P_SpawnMobj(mo.x, mo.y, mo.z, MT_FIREPILLAR_FIRESPAWN)
	spawner.angle = mo.angle
	return
end

function A_FirePillarFire(mo)
	if mo.fuse <= 1 then
		P_KillMobj(mo)
		return
	end
	
	if P_MobjFlip(mo) > 0 then
		if mo.z > mo.extravalue1 then
			P_KillMobj(mo)
			return
		end
	else
		if mo.z < mo.extravalue1 then
			P_KillMobj(mo)
			return
		end
	end
	return
end

function A_FirePillarFireDead(mo)
	local truc = P_SpawnMobj(mo.x + P_RandomRange(-32, 32)*mapobjectscale, mo.y + P_RandomRange(-32, 32)*mapobjectscale, mo.z, MT_BOOMPARTICLE)
		truc.scale = 3*mo.scale/2
		truc.color = SKINCOLOR_RED
		truc.momx = P_RandomRange(-8, 8)*mapobjectscale
		truc.momy = P_RandomRange(-8, 8)*mapobjectscale
		truc.momz = 12*mapobjectscale
		truc.tics = TICRATE/4;
		truc.flags = $ & ~MF_NOGRAVITY
	return
end

states[S_FIREPILLAR_START] = {
        sprite = SPR_NULL,
        tics = STARTTIME,
		nextstate = S_FIREPILLAR_WAIT,
}

states[S_FIREPILLAR_WAIT] = {
        sprite = SPR_NULL,
        tics = TICRATE*6,
		nextstate = S_FIREPILLAR_WARN,
		action = A_FirePillarWait
}

states[S_FIREPILLAR_WAIT_LONG] = {
        sprite = SPR_NULL,
        tics = TICRATE*12,
		nextstate = S_FIREPILLAR_WARN
}

states[S_FIREPILLAR_WARN] = {
        sprite = SPR_NULL,
        tics = TICRATE*3,
		nextstate = S_FIREPILLAR_ACTIVE,
		action = A_FirePillarWarn
}

states[S_FIREPILLAR_ACTIVE] = {
        sprite = SPR_NULL,
        tics = TICRATE*4,
		nextstate = S_FIREPILLAR_WAIT,
		action = A_FirePillarActive
}

states[S_FIREPILLAR_FIRE] = {
        sprite = SPR_DFLM,
		frame = I,
        tics = 1,
		nextstate = S_FIREPILLAR_FIRE,
		action = A_FirePillarFire,
}

states[S_FIREPILLAR_FIREDEAD] = {
        sprite = SPR_NULL,
        tics = 1,
		nextstate = S_NULL,
		action = A_FirePillarFireDead,
}

states[S_FIREPILLAR_FIRESPAWN] = {
        sprite = SPR_NULL,
        tics = TICRATE*2,
		nextstate = S_NULL
}

local function FirePillarSpawnerThinker(mo)
	if not mo then return end
	if not mo.valid then return end

	mo.extravalue1 = $ + FixedMul(FireGrowthRate, mapobjectscale)*P_MobjFlip(mo)
	if P_MobjFlip(mo) > 0 then
		if mo.z + mo.extravalue1 > mo.ceilingz then
			mo.extravalue1 = mo.ceilingz
		end
	else
		if mo.z - mo.extravalue1 < mo.floorz then
			mo.extravalue1 = mo.floorz
		end
	end
	
	if leveltime % 2 == 0 then
		local fire = P_SpawnMobj(mo.x, mo.y, mo.z, MT_FIREPILLAR_FIRE)
		fire.target = mo
		fire.momz = FixedMul(mo.extravalue1/8, mapobjectscale)*P_MobjFlip(mo)
		fire.scale = 4*mapobjectscale
		fire.fuse = TICRATE/3 + P_RandomRange(0, TICRATE/4)
		fire.extravalue1 = mo.z + mo.extravalue1
		fire.angle = mo.angle
	end
end
addHook("MobjThinker", FirePillarSpawnerThinker, MT_FIREPILLAR_FIRESPAWN)

local function DoFirePillarFatality(player, angle)
    if player.spectator then return end
    if not player.mo then return end
	if not player.mo.valid then return end
    if player.playerstate ~= PST_LIVE then return end
    
	if not fatalities.StartFatality(player, FirePillar, 3*TICRATE/2) then return end
	
    local mo = player.mo
	local minSpeed = 42*mapobjectscale
	local maxSpeed = 80*mapobjectscale
	local speed = R_PointToDist2(0, 0, mo.momx, mo.momy)
	speed = min(max(speed, minSpeed), maxSpeed)
	mo.angle = angle
	P_InstaThrust(mo, angle, speed)
	
	player.fatalitystuff.angle = angle

    local deadplayer = fatalities.CreateDeadPlayer(player, FirePillar)
	P_InstaThrust(deadplayer, angle, speed)
	deadplayer.angle = angle
	deadplayer.friction = FRACUNIT

	deadplayer.colorized = true
	deadplayer.color = SKINCOLOR_MAROON
	
	deadplayer.reactiontime = leveltime
	
	S_StartSound(deadplayer, sfx_khurt2)

    mo.flags = $|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING
    mo.flags2 = $|MF2_DONTDRAW
    mo.sprite = SPR_NULL
end

local function FirePillarFireSpecial(mo, toucher)
	if toucher and toucher.player and toucher.valid then
		local ks = toucher.player.kartstuff
		if toucher.player.fatalitystuff and toucher.player.fatalitystuff.timer > 0 then return true end
		-- don't murder invulnerable players
		if (ks[k_invincibilitytimer] > 0 or ks[k_hyudorotimer] > 0 or ks[k_growshrinktimer] > 0
			or ks[k_respawn] > 0 or (toucher.player.powers[pw_flashing] > 0 and ks[k_spinouttimer] == 0 and ks[k_squishedtimer] == 0)) then
			K_DoInstashield(toucher.player)
			return true
		end
		DoFirePillarFatality(toucher.player, mo.angle)
		fatalities.SendHitfeed(toucher.player)
	end
	return true
end
addHook("TouchSpecial", FirePillarFireSpecial, MT_FIREPILLAR_FIRE)

local function FirePillarFatalityPlayerThink(p)
	if p.fatalitystuff == nil then return end
	if p.fatalitystuff.fakeplayer == nil then return end
	if not p.fatalitystuff.fakeplayer.valid then return end
	if not p.mo then return end
	
    P_MoveOrigin(p.mo, 
        p.fatalitystuff.fakeplayer.x,
        p.fatalitystuff.fakeplayer.y,
        p.fatalitystuff.fakeplayer.z + 1
    )
	p.mo.momx = 0
	p.mo.momy = 0
	p.mo.momz = 0
	
	if (3*TICRATE/2 - p.fatalitystuff.timer) > TurnAroundTime then
		p.mo.angle = p.fatalitystuff.angle + TurnAroundOffset
	else
		p.mo.angle = p.fatalitystuff.angle + (TurnAroundOffset/TurnAroundTime)*(3*TICRATE/2 - p.fatalitystuff.timer)
	end
end

local function LavaBoil(mo)
    for i = 1, 2 do
        local truc = P_SpawnMobj(mo.x + P_RandomRange(-3, 3)*mapobjectscale, mo.y + P_RandomRange(-3, 3)*mapobjectscale, mo.z, MT_BOOMEXPLODE)
        truc.scale = 3*mo.scale/4
        truc.color = SKINCOLOR_RED
        truc.momx = P_RandomRange(-2, 2)*mapobjectscale
        truc.momy = P_RandomRange(-2, 2)*mapobjectscale
    end
end

local function LavaExplode(mo)
    for i = 1, 4 do
        local truc = P_SpawnMobj(mo.x, mo.y, mo.z, MT_BOOMPARTICLE)
        truc.scale = 3*mo.scale/4
        truc.color = SKINCOLOR_KETCHUP
        truc.momx = P_RandomRange(-18, 18)*mapobjectscale
        truc.momy = P_RandomRange(-18, 18)*mapobjectscale
        truc.momz = P_RandomRange(20, 32)*mapobjectscale
        truc.tics = TICRATE;
    end
end

local function BurningExplode(mo)
	for i = 1, 12 do
		local truc = P_SpawnMobj(mo.x + P_RandomRange(-24, 24)*mapobjectscale, mo.y + P_RandomRange(-24, 24)*mapobjectscale, mo.z, MT_FATALBLOOD)
        truc.scale = 3*mo.scale
		truc.destscale = mo.scale
		P_InstaThrust(truc, mo.angle, P_RandomRange(16, 48)*mapobjectscale)
		truc.momz = P_RandomRange(16, 38)*mapobjectscale
		truc.tics = $ + P_RandomRange(0, 3)
	end
	for i = 1, 8 do
		local truc = P_SpawnMobj(mo.x + P_RandomRange(-48, 48)*mapobjectscale, mo.y + P_RandomRange(-48, 48)*mapobjectscale, mo.z, MT_FATALGIB)
		truc.frame = P_RandomRange(A, D)
        truc.scale = 3*mo.scale
		truc.destscale = 2*mo.scale
		truc.friction = 0
		P_InstaThrust(truc, mo.angle, P_RandomRange(8, 16)*mapobjectscale)
		truc.momz = P_RandomRange(20, 35)*mapobjectscale
		truc.rollmodel = true
        truc.rollangle = P_RandomRange(0, 360)*ANG1
	end
end

local function Burst(mo)
	for i = 1, 3 do
		local truc = P_SpawnMobj(mo.x + P_RandomRange(-4, 4)*mapobjectscale, mo.y + P_RandomRange(-4, 4)*mapobjectscale, mo.z, MT_FATALBLOOD)
        truc.scale = 2*mo.scale
		truc.destscale = mo.scale
        truc.momx = P_RandomRange(-2, 2)*mapobjectscale
        truc.momy = P_RandomRange(-2, 2)*mapobjectscale
		truc.momz = P_RandomRange(8, 16)*mapobjectscale
	end
end

local function FirePillarFatalityDeadPlayerThink(mo)
	if leveltime % 3 == 0 then
		LavaBoil(mo)
	end
	
	if leveltime == mo.reactiontime + TurnAroundTime then
		mo.color = SKINCOLOR_BLACK
        mo.rollmodel = true
        mo.rollangle = 30*ANG1
		mo.friction = 62914
		
        S_StopSound(mo)
        S_StartSound(mo, sfx_s3k4b)
		S_StartSound(mo, sfx_fatalx)

		LavaExplode(mo)
		BurningExplode(mo)
		
		mo.angle = $-45*ANG1
	end
	if leveltime >= mo.reactiontime + TurnAroundTime then
		if leveltime < mo.reactiontime + TurnAroundTime + 8 then
			mo.rollangle = $ + 15*ANG1
		end
		if leveltime == mo.reactiontime + TurnAroundTime + 8 then
			mo.rollangle = 45*ANG1
		end
		if leveltime >= mo.reactiontime + TurnAroundTime + 8 then
			if P_IsObjectOnGround(mo) then
				mo.momx = 0
				mo.momy = 0
			end
			if leveltime % 17 == 0 then
				Burst(mo)
			end
		end
	end
end

fatalities.AddFatality(
	FirePillar, 
	FirePillarFatalityPlayerThink, 
	FirePillarFatalityDeadPlayerThink
)