if not fatalities then return end

local LavaPit = "LavaPit"

local function LavaFatalityPlayerThink(p)
	if p.fatalitystuff == nil then return end
	if p.fatalitystuff.fakeplayer == nil then return end
	if not p.fatalitystuff.fakeplayer.valid then return end
	if not p.mo then return end
	
    P_MoveOrigin(p.mo, 
        (p.fatalitystuff.x + p.fatalitystuff.fakeplayer.x) / 2, 
        (p.fatalitystuff.y + p.fatalitystuff.fakeplayer.y) / 2, 
        p.fatalitystuff.z + ((p.fatalitystuff.fakeplayer.z - p.fatalitystuff.z) / 8)
    )
	p.mo.momx = 0
	p.mo.momy = 0
	p.mo.momz = 0
end

local function LavaExplode(mo)
    for i = 1, 4 do
        local truc = P_SpawnMobj(mo.x, mo.y, mo.z, MT_BOOMPARTICLE)
        truc.scale = mo.scale
        truc.color = SKINCOLOR_KETCHUP
        truc.momx = P_RandomRange(-18, 18)*mapobjectscale
        truc.momy = P_RandomRange(-18, 18)*mapobjectscale
        truc.momz = P_RandomRange(20, 32)*mapobjectscale
        truc.tics = TICRATE*2;
    end
end

local function LavaBoil(mo)
    for i = 1, 2 do
        local truc = P_SpawnMobj(mo.x + P_RandomRange(-3, 3)*mapobjectscale, mo.y + P_RandomRange(-3, 3)*mapobjectscale, mo.z, MT_BOOMEXPLODE)
        truc.scale = 3*mo.scale/2
        truc.color = SKINCOLOR_RED
        truc.momx = P_RandomRange(-2, 2)*mapobjectscale
        truc.momy = P_RandomRange(-2, 2)*mapobjectscale
        truc.momz = 2*mapobjectscale
    end
end

local function LavaFatalityDeadPlayerThink(mo)
    if P_IsObjectOnGround(mo) and mo.cusval == 0 then
        mo.flags = $|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING
        mo.momx = 0
        mo.momy = 0
        mo.momz = -mapobjectscale*P_MobjFlip(mo)
        mo.cusval = 1
        mo.reactiontime = leveltime
        mo.rollmodel = true
        mo.rollangle = 30*ANG1
        
        LavaExplode(mo)
        S_StopSound(mo)
        S_StartSound(mo, sfx_gloop)
        S_StartSound(mo, sfx_khurt2)
    end
    
    if mo.cusval == 1 then
        if leveltime == mo.reactiontime + TICRATE/4 then
			local smoldering = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SMOLDERING)
			K_MatchGenericExtraFlags(smoldering, mo)
			smoldering.tics = TICRATE*3

            S_StopSound(mo)
            S_StartSound(mo, sfx_kc41)
            A_FZBoomSmoke(mo)
            LavaExplode(mo)

            mo.colorized = true
            mo.color = SKINCOLOR_BLACK
        end
        if leveltime % 4 == 0 then
            LavaBoil(mo)
        end
    end
end

local function DoLavaFatalityPit(line, mo)
    if not mo.valid then return end
    if not mo.player then return end
    if mo.player.spectator then return end
    if mo.player.playerstate ~= PST_LIVE then return end
    
    local p = mo.player
	if not fatalities.StartFatality(p, LavaPit, 3*TICRATE/2) then return end
    local deadplayer = fatalities.CreateDeadPlayer(p, LavaPit)

    mo.flags = $|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING
    mo.flags2 = $|MF2_DONTDRAW
    mo.sprite = SPR_NULL
    mo.momx = 0
    mo.momy = 0
    mo.momz = 0
    S_StopSound(mo)

    S_StartSound(deadplayer, sfx_khurt1)
	
	fatalities.SendHitfeed(p)
end

addHook("LinedefExecute", DoLavaFatalityPit, "FATALITYLAVA")

fatalities.AddFatality(
	LavaPit, 
	LavaFatalityPlayerThink, 
	LavaFatalityDeadPlayerThink
)