-- fatality.lua for SRB2Kart
-- adds special death animations a la Motor Kombat
-- by minenice
local scriptversion = 2
if fatalities and fatalities.version > scriptversion then return end
if (not fatalities) or (fatalities and fatalities.version < scriptversion) then
	rawset(_G, "fatalities", {
		playerthinkers = {},
		deadthinkers = {},
		version = 0
	})
end

--apparently this makes shit faster? wtf?
-- after years of c# I do NOT miss scripting for this game lmao
local k_hyudorotimer = k_hyudorotimer
local k_spinouttimer = k_spinouttimer
local k_wipeoutslow = k_wipeoutslow
local k_squishedtimer = k_squishedtimer
local k_eggmanexplode = k_eggmanexplode
local k_sneakertimer = k_sneakertimer
local k_invincibilitytimer = k_invincibilitytimer
local k_rocketsneakertimer = k_rocketsneakertimer
local k_itemheld = k_itemheld
local k_eggmanheld = k_eggmanheld
local pw_invulnerability = pw_invulnerability
local pw_flashing = pw_flashing

freeslot(
    "MT_DEADPLAYER",
	"MT_FATALBLOOD",
	"MT_FATALGIB",
	
	"S_FATALGIB",
	"S_FATALBLOOD",
	
	"SPR_FTGB",	-- gibs
	"SPR_FTBL", -- blood

    "sfx_fatal1",
    "sfx_fatal2",
	"sfx_fatalx",
	
	"sfx_fatala",
	"sfx_fatalb",
	"sfx_fatalc",
	"sfx_fatald",
	"sfx_fatale",
	"sfx_fatalf",
	"sfx_fatalg",
	"sfx_fatalh",
	"sfx_fatali",
	"sfx_fatalj"
)

mobjinfo[MT_DEADPLAYER] = {
	doomednum = -1,
    radius = 8*FRACUNIT,
    height = 8*FRACUNIT,
    flags = MF_SLIDEME|MF_SCENERY
}

mobjinfo[MT_FATALGIB] = {
	doomednum = -1,
	spawnstate = S_FATALGIB,
    radius = 2*FRACUNIT,
    height = 2*FRACUNIT,
    flags = MF_BOUNCE|MF_NOCLIPTHING|MF_SCENERY
}

mobjinfo[MT_FATALBLOOD] = {
	doomednum = -1,
	spawnstate = S_FATALBLOOD,
    radius = 2*FRACUNIT,
    height = 2*FRACUNIT,
    flags = MF_NOCLIPTHING|MF_STICKY|MF_SCENERY
}

states[S_FATALBLOOD] = {
        sprite = SPR_FTBL,
		frame = A|FF_ANIMATE,
        tics = TICRATE/2,
		nextstate = S_NULL,
		var1 = 3,
		var2 = 3
}

states[S_FATALGIB] = {
        sprite = SPR_FTGB,
		frame = A,
        tics = TICRATE*3,
		nextstate = S_NULL,
}

-- modified from xItemLib
local BASEVIDWIDTH  = 320
local BASEVIDHEIGHT = 200

local HUD_X = BASEVIDWIDTH/2 - 105/2
local HUD_Y = 42

local HUD1_X = BASEVIDWIDTH/4 - 105/2
local HUD1_Y = 32

local HUD2_X = 3*BASEVIDWIDTH/4 - 105/2
local HUD2_Y = 32

local function findHudFlags(v, p, c)
    if splitscreen < 2 then -- don't change shit for THIS splitscreen.
        local HUD_Y_OFF = HUD_Y
        if splitscreen == 1 then HUD_Y_OFF = $-2 end
        
        if c.pnum == 1 then
            return HUD_X, HUD_Y_OFF, V_SNAPTOTOP
        else
            return HUD_X, HUD_Y_OFF, V_SPLITSCREEN
        end
    else -- now we're having a fun game.
        if c.pnum == 1 or c.pnum == 3 then -- If we are P1 or P3...
            return HUD1_X, HUD1_Y, (c.pnum == 3 and V_SPLITSCREEN or V_SNAPTOTOP)    -- flip P3 to the bottom.    
        else -- else, that means we're P2 or P4.
            return HUD2_X, HUD2_Y, (c.pnum == 4 and V_SPLITSCREEN or V_SNAPTOTOP)
        end
    end
end

function fatalities.FatalityData()
    return {
        timer = 0,
		hudtimer = 0,
        type = nil,
        fakeplayer = nil,
        x = 0,
        y = 0,
        z = 0,
		angle = 0,
		
		fatalblame = nil,
		fatalblametimer = 0,
		
		debug_viewreal = false
    }
end

function fatalities.PlayerThink(p)
    if p.fatalitystuff == nil then
		fatalities.AssignPlayerData(p)
	end
	if (not p.valid) or p.spectator then
		return
	end
	if (not p.mo) or (not p.mo.valid) or p.exiting then
		if p.fatalitystuff.fakeplayer ~= nil then
			P_SetOrigin(p.mo, 
				p.fatalitystuff.fakeplayer.x, 
				p.fatalitystuff.fakeplayer.y, 
				p.fatalitystuff.fakeplayer.z
			)
		end
		return
	end
	local mo = p.mo

	if p.fatalitystuff.hudtimer then
		p.fatalitystuff.hudtimer = $ - 1
	end
	
	if p.fatalitystuff.fatalblametimer then
		if P_IsObjectOnGround(mo)
			and not p.kartstuff[k_spinouttimer]
			and not p.kartstuff[k_wipeoutslow] then
			p.fatalitystuff.fatalblametimer = $-1
		end
		if p.fatalitystuff.fatalblametimer == 0 then
			fatalities.ClearFatalBlame(p)
		end
	end

    if p.fatalitystuff.timer then
        p.fatalitystuff.timer = $ - 1

        mo.flags = $|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING
		if not p.fatalitystuff.debug_viewreal then
			mo.flags2 = $|MF2_DONTDRAW
			mo.sprite = SPR_NULL
			p.kartstuff[k_hyudorotimer] = 2
			p.powers[pw_flashing] = 2
		end
		p.kartstuff[k_squishedtimer] = 2

		local fn = fatalities.playerthinkers[p.fatalitystuff.type]
		if fn ~= nil and type(fn) == "function" then
			local status, err = pcall(fatalities.playerthinkers[p.fatalitystuff.type], p)
			if not status then
				error(err, 2)
			end
		end
        
        S_StopSound(mo)
        if p.fatalitystuff.timer == 0 then
            p.playerstate = PST_DEAD
			p.fatalitystuff.fakeplayer = nil
			p.fatalitystuff.type = nil
			S_StartSound(nil, sfx_fatal1 + P_RandomKey(2), p)
			p.fatalitystuff.hudtimer = TICRATE
        end
    end
end

function fatalities.DeadPlayerThink(mo)
    if not mo.valid then return end
	if mo.fatalitytype == nil then return end

    local fn = fatalities.deadthinkers[mo.fatalitytype]
	if fn ~= nil and type(fn) == "function" then
		local status, err = pcall(fatalities.deadthinkers[mo.fatalitytype], mo)
		if not status then
			error(err, 2)
		end
	end
end

function fatalities.FatalityHud(v, p, c)
	if p.fatalitystuff == nil then return end
	if p.fatalitystuff.hudtimer then
		local patch = v.cachePatch("FATALHUD")
		local fx, fy, fflags = findHudFlags(v, p, c)
		v.draw(fx, fy, patch, V_HUDTRANS|fflags)
	end
end

function fatalities.StartFatality(player, name, time)
	if player.fatalitystuff == nil then
        fatalities.AssignPlayerData(player)
    end
    if player.fatalitystuff.timer > 0 then return false end

	player.fatalitystuff.timer = time
    player.fatalitystuff.type = name
    player.fatalitystuff.x = player.mo.x
    player.fatalitystuff.y = player.mo.y
    player.fatalitystuff.z = player.mo.z
	player.fatalitystuff.angle = player.frameangle
	player.fatalitystuff.debug_viewreal = false
	
	player.kartstuff[k_eggmanexplode] = 0
	player.kartstuff[k_sneakertimer] = 0
	if player.kartstuff[k_invincibilitytimer] then
		player.kartstuff[k_invincibilitytimer] = 1
	end
	if player.kartstuff[k_rocketsneakertimer] then
		player.kartstuff[k_rocketsneakertimer] = 1
	end
	if player.kartstuff[k_itemheld] or player.kartstuff[k_eggmanheld] 
		or (player.mo and player.mo.hnext and player.mo.hnext.valid) then
		K_DropItems(player)
	end
	
	if acrobatics then
		ac_trickReset(player, nil)
	end
	return true
end

function fatalities.CreateDeadPlayer(player, fatalitytype)
	local mo = player.mo
	local deadplayer = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DEADPLAYER)
    K_MatchGenericExtraFlags(mo, deadplayer)
    deadplayer.momx = 3*mo.momx/4
    deadplayer.momy = 3*mo.momy/4
    deadplayer.momz = mo.momz
    deadplayer.scale = mo.scale
    deadplayer.angle = player.frameangle
    deadplayer.skin = mo.skin
    deadplayer.state = mo.state
    deadplayer.color = player.skincolor
	if fatalitytype == nil and player.fatalitystuff ~= nil then
		deadplayer.fatalitytype = player.fatalitystuff.fatalitytype
	else
		deadplayer.fatalitytype = fatalitytype
	end
	deadplayer.fuse = 2*TICRATE
    deadplayer.eflags = $ & ~MFE_ONGROUND

    -- saturn / neptune / *other* custom builds
    if mo.spritexscale then
        deadplayer.spritexscale = mo.spritexscale
    end
    if mo.spriteyscale then
        deadplayer.spriteyscale = mo.spriteyscale
    end
    if mo.spritexoffset then
        deadplayer.spritexoffset = mo.spritexoffset
    end
    if mo.spriteyoffset then
        deadplayer.spriteyoffset = mo.spriteyoffset
    end
    if mo.sloperoll then
        deadplayer.sloperoll = mo.sloperoll
    end
    if mo.rollmodel then
        deadplayer.rollmodel = mo.rollmodel
    end
    if mo.rollangle then
        deadplayer.rollangle = mo.rollsum
    end

    deadplayer.target = mo
    player.fatalitystuff.fakeplayer = deadplayer

	return deadplayer
end

function fatalities.AddFatality(name, playerthinker, deadplayerthinker)
	if playerthinker ~= nil and type(playerthinker) == "function" then
		fatalities.playerthinkers[name] = playerthinker
	end
	if deadplayerthinker ~= nil and type(deadplayerthinker) == "function" then
		fatalities.deadthinkers[name] = deadplayerthinker
	end
end

function fatalities.AssignPlayerData(player)
	player.fatalitystuff = fatalities.FatalityData()
end

-- fatalblame for hitfeed support
local function generateHFForPlayer(p)
	if p and p.valid and p.mo and p.mo.valid then
		return {{p.name, p.mo.hf_overridenamecolor or p.skincolor}, {skins[p.mo.skin].facemmap, p.skincolor}, p}
	else
		return {{}, {}}
	end
end
function fatalities.SendHitfeed(player)
	local source = nil
	if player.fatalitystuff and player.fatalitystuff.fatalblame and player.fatalitystuff.fatalblame.valid and player.fatalitystuff.fatalblame ~= player then
		S_StartSound(nil, P_RandomRange(sfx_fatala, sfx_fatalj), player.fatalitystuff.fatalblame)
		if (hitfeed) then
			source = generateHFForPlayer(player.fatalitystuff.fatalblame)
		end
	end
	if (hitfeed) then
		local victim = generateHFForPlayer(player)
		HF_SendHitMessage(source, victim, "HF_FATAL")
	end
	fatalities.ClearFatalBlame(player)
end
-- stolen and slightly modified from Sunflower's Garden's FallBlame
function fatalities.SetFatalBlame(player, attacker)
    player.fatalitystuff.fatalblametimer = 3*TICRATE
    player.fatalitystuff.fatalblame = attacker
end

function fatalities.ClearFatalBlame(player)
    player.fatalitystuff.fatalblametimer = 0
    player.fatalitystuff.fatalblame = nil
end

function fatalities.ObjectCollide(pmo, mo)
    if pmo.z > (mo.z + mo.height) or mo.z > (pmo.z + pmo.height) then return end

    local p1 = pmo.player
    local p2

    if mo.player then
        local p2 = mo.player

        if (p1.powers[pw_flashing] and not p1.kartstuff[k_spinouttimer]) or (p2.powers[pw_flashing] and not p2.kartstuff[k_spinouttimer]) then return end
		if p1.kartstuff[k_hyudorotimer] or p2.kartstuff[k_hyudorotimer] then return end

        fatalities.SetFatalBlame(p2, p1)
    elseif mo.target ~= nil and mo.target.player ~= nil then
        p2 = mo.target and mo.target.player
    end

    if p2 and (p2 ~= p1) then
        fatalities.SetFatalBlame(p1, p2)
    end
end
addHook("MobjCollide", fatalities.ObjectCollide, MT_PLAYER)
addHook("MobjMoveCollide", fatalities.ObjectCollide, MT_PLAYER)

addHook("PlayerSpin", function(player, _, inflictor)
    if inflictor and inflictor.player then
        fatalities.SetFatalBlame(player, inflictor.player)
    end
end)

-- Rare cases of player being squished in air
addHook("PlayerSquish", function(player, _, inflictor)
    if inflictor and inflictor.player then
        fatalities.SetFatalBlame(player, inflictor.player)
    end
end)

addHook("PlayerExplode", function(player, _, inflictor)
    if inflictor and inflictor.player then
        fatalities.SetFatalBlame(player, inflictor.player)
    end
end)
-- end fatalblame

if fatalities.version == 0 then
	hud.add(fatalities.FatalityHud, "game")

	addHook("ThinkFrame", do
		for i = 0, #players-1 do
			if players[i] then
				fatalities.PlayerThink(players[i])
			end
		end
	end)

	addHook("MobjThinker", fatalities.DeadPlayerThink, MT_DEADPLAYER)
end
fatalities.version = scriptversion